/*
 *  AVRVM, a virtual machine which emulates an Atmel AVR CPU.
 *  Copyright (C) 2010  Joakim Soderlund
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include "cpu.h"

ATMega16 *get_atmega16() {
	ATMega16 *cpu = (ATMega16*) calloc(1, sizeof(ATMega16));
	
	cpu->gen = cpu->sram;
	cpu->io = cpu->sram + (sizeof(unsigned char) * 32);
	
	cpu->sreg = cpu->io + (sizeof(unsigned char) * 0x3F);
	
	//          --- Be careful with the endianess! ---
	// Always wrap calls through htons and ntohs when using sp!
	cpu->sp = (unsigned short*) cpu->io + (sizeof(unsigned char) * 0x3D);
	
	return cpu;
}

