/*
 *  AVRVM, a virtual machine which emulates an Atmel AVR CPU.
 *  Copyright (C) 2010  Joakim Soderlund
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define SREG_C 0
#define SREG_Z 1
#define SREG_N 2
#define SREG_V 3
#define SREG_S 4
#define SREG_H 5
#define SREG_T 6
#define SREG_I 7

typedef struct {
	unsigned short *pm;       // Program memory.
	unsigned short ir;        // Instruction register.
	
	unsigned char sram[1120]; // Static RAM.
	unsigned char *gen;       // General registers.
	unsigned char *io;        // IO Registers.
	
	unsigned int pc;          // Program counter.
	unsigned char *sreg;      // Status register.
	
	unsigned short *sp;       // Stack pointer.
} ATMega16;

ATMega16 *get_atmega16();

